/* GCC */
#include <set>
#include <math.h>
#include <vector>
#include <iostream>
#include <algorithm>

#define Ri(a) scanf("%d", &a)
#define Ri2(a,b) scanf("%d%d", &a, &b)
#define Wi(a) printf("%d ", a)
#define Wi2(a,b) printf("%d %d ", a, b)
#define Wie(a) printf("%d\n", a)
#define Wie2(a,b) printf("%d %d\n", a, b)
#define F first
#define S second
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for( int i = (a), _n_ = (b); i <= _n_; i++ )
#define FORD(i,a,b) for( int i = (a), _n_ = (b); i >= _n_; i-- )
#define forn(i,n) FOR(i,0,(n)-1)
#define pii pair< int, int >

using namespace std;

int t[400010][2], szt, w, h, n;

void build( int n ) {
     szt = n << 2;
     forn( i, szt + 1 ) t[i][0] = t[i][1] = 0;
}

inline int maxx() {
    return t[1][0];
}

inline void push( int v ) {
     if( (v << 1) <= szt ) t[v << 1][1] += t[v][1];
     if( (v << 1) + 1 <= szt ) t[(v << 1) + 1][1] += t[v][1];
     t[v][0] += t[v][1];
     t[v][1] = 0; 
}

void add( int v, int tl, int tr, int l, int r, int delta ) {
     push(v);
     if( l > r ) return;
     if( tl == l && tr == r ) {
         t[v][1] += delta;
         push(v);
         return;
     }
     
     int tm = ( tl + tr ) >> 1;
     add( v << 1, tl, tm, l, min( tm, r ), delta );
     add( (v << 1) + 1, tm + 1, tr, max( l, tm + 1 ), r, delta );
     t[v][0] = max( t[v << 1][0], t[(v << 1) + 1][0] );
     return;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    
    int n, m;
    Ri( n );
    build( n );
    Ri( m );
    forn( i, m ) {
          int tp;
          Ri( tp );
          if( tp )
              Wie( maxx() );
          else {
               int l, r, delta;
               Ri2( l, r );
               Ri( delta );
               add( 1, 0, n - 1, l - 1, r - 1, delta );
          }
    }
    
    return 0;
}
